﻿using System;
using System.Collections.Generic;
using System.Data.Entity;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace musicschoolapp.Pages
{
    /// <summary>
    /// Логика взаимодействия для MenuPage.xaml
    /// </summary>
    public partial class MenuPage : Page
    {
        StudentEditingPage studentEditingPage;
        CourseEditingPage courseEditingPage;
        public EnrollmentEditingPage enrollmentEditingPage;
        Instr instr = new Instr();
        public MenuPage(StudentEditingPage s, CourseEditingPage c, EnrollmentEditingPage e, Instr i)
        {
            enrollmentEditingPage = e;
            courseEditingPage = c;
            studentEditingPage = s;
            instr = i;
            InitializeComponent();
        }

        private void courseButton_Click(object sender, RoutedEventArgs e)
        {
            NavigationService.Navigate(courseEditingPage);
        }

        private void studentButton_Click(object sender, RoutedEventArgs e)
        {
            NavigationService.Navigate(studentEditingPage);
        }

        private void enrollmentButton_Click(object sender, RoutedEventArgs e)
        {
            NavigationService.Navigate(enrollmentEditingPage);
        }

        private void quickEnrollButton_Click(object sender, RoutedEventArgs e)
        {
            NavigationService.Navigate(new QuickEnroll());
        }

        private void instrButton_Click(object sender, RoutedEventArgs e)
        {
            NavigationService.Navigate(instr);
        }

        private void adminButton_Click(object sender, RoutedEventArgs e)
        {
            Process.Start("AdminEditingApp\\admin\\etc\\bin\\Debug\\etc.exe");
            Environment.Exit(0);
        }
    }
}
